searchNodes=[{"doc":"Generates a interactor and its tests. mix use_case.gen.interactor DoSomething.Cool The first argument is the interactor name.","ref":"Mix.Tasks.UseCase.Gen.Interactor.html","title":"Mix.Tasks.UseCase.Gen.Interactor","type":"task"},{"doc":"","ref":"Mix.Tasks.UseCase.Gen.Interactor.html#run/2","title":"Mix.Tasks.UseCase.Gen.Interactor.run/2","type":"function"},{"doc":"Generates context, schema, migration and tests for a resource. mix use_case.gen.phx_resource Posts Post posts title content image likes:int The first argument is the context name, the second the resource name, the third the database table name for the resource and the others the resource fields.","ref":"Mix.Tasks.UseCase.Gen.PhxResource.html","title":"Mix.Tasks.UseCase.Gen.PhxResource","type":"task"},{"doc":"","ref":"Mix.Tasks.UseCase.Gen.PhxResource.html#run/2","title":"Mix.Tasks.UseCase.Gen.PhxResource.run/2","type":"function"},{"doc":"Generates context, schema, migration, controllers, html templates, views and tests for a resource. mix use_case.gen.phx_resource Posts Post posts title content image likes:int The first argument is the context name, the second the resource name, the third the database table name for the resource and the others the resource fields.","ref":"Mix.Tasks.UseCase.Gen.PhxResourceHtml.html","title":"Mix.Tasks.UseCase.Gen.PhxResourceHtml","type":"task"},{"doc":"","ref":"Mix.Tasks.UseCase.Gen.PhxResourceHtml.html#run/2","title":"Mix.Tasks.UseCase.Gen.PhxResourceHtml.run/2","type":"function"},{"doc":"Generates context, schema, migration, controllers, views and tests for a resource. mix use_case.gen.phx_resource Posts Post posts title content image likes:int The first argument is the context name, the second the resource name, the third the database table name for the resource and the others the resource fields.","ref":"Mix.Tasks.UseCase.Gen.PhxResourceJson.html","title":"Mix.Tasks.UseCase.Gen.PhxResourceJson","type":"task"},{"doc":"","ref":"Mix.Tasks.UseCase.Gen.PhxResourceJson.html#run/2","title":"Mix.Tasks.UseCase.Gen.PhxResourceJson.run/2","type":"function"},{"doc":"Generates context, schema, migration, controllers, temple templates, views and tests for a resource. mix use_case.gen.phx_resource Posts Post posts title content image likes:int The first argument is the context name, the second the resource name, the third the database table name for the resource and the others the resource fields.","ref":"Mix.Tasks.UseCase.Gen.PhxResourceTemple.html","title":"Mix.Tasks.UseCase.Gen.PhxResourceTemple","type":"task"},{"doc":"","ref":"Mix.Tasks.UseCase.Gen.PhxResourceTemple.html#run/2","title":"Mix.Tasks.UseCase.Gen.PhxResourceTemple.run/2","type":"function"},{"doc":"","ref":"Mix.Tasks.UseCase.Gen.Pr.html","title":"Mix.Tasks.UseCase.Gen.Pr","type":"task"},{"doc":"","ref":"Mix.Tasks.UseCase.Gen.Pr.html#run/2","title":"Mix.Tasks.UseCase.Gen.Pr.run/2","type":"function"},{"doc":"","ref":"Mix.Tasks.UseCase.Gen.Prh.html","title":"Mix.Tasks.UseCase.Gen.Prh","type":"task"},{"doc":"","ref":"Mix.Tasks.UseCase.Gen.Prh.html#run/2","title":"Mix.Tasks.UseCase.Gen.Prh.run/2","type":"function"},{"doc":"","ref":"Mix.Tasks.UseCase.Gen.Prj.html","title":"Mix.Tasks.UseCase.Gen.Prj","type":"task"},{"doc":"","ref":"Mix.Tasks.UseCase.Gen.Prj.html#run/2","title":"Mix.Tasks.UseCase.Gen.Prj.run/2","type":"function"},{"doc":"","ref":"Mix.Tasks.UseCase.Gen.Prt.html","title":"Mix.Tasks.UseCase.Gen.Prt","type":"task"},{"doc":"","ref":"Mix.Tasks.UseCase.Gen.Prt.html#run/2","title":"Mix.Tasks.UseCase.Gen.Prt.run/2","type":"function"},{"doc":"","ref":"UseCase.html","title":"UseCase","type":"module"},{"doc":"","ref":"UseCase.html#call/1","title":"UseCase.call/1","type":"function"},{"doc":"","ref":"UseCase.html#call/2","title":"UseCase.call/2","type":"function"},{"doc":"","ref":"UseCase.html#call/3","title":"UseCase.call/3","type":"function"},{"doc":"","ref":"UseCase.html#call!/1","title":"UseCase.call!/1","type":"function"},{"doc":"","ref":"UseCase.html#call!/2","title":"UseCase.call!/2","type":"function"},{"doc":"","ref":"UseCase.html#call!/3","title":"UseCase.call!/3","type":"function"},{"doc":"","ref":"UseCase.html#pipe/1","title":"UseCase.pipe/1","type":"function"},{"doc":"","ref":"UseCase.html#pipe/2","title":"UseCase.pipe/2","type":"function"},{"doc":"","ref":"UseCase.html#pipe/3","title":"UseCase.pipe/3","type":"function"},{"doc":"","ref":"UseCase.html#pipe!/1","title":"UseCase.pipe!/1","type":"function"},{"doc":"","ref":"UseCase.html#pipe!/2","title":"UseCase.pipe!/2","type":"function"},{"doc":"","ref":"UseCase.html#pipe!/3","title":"UseCase.pipe!/3","type":"function"},{"doc":"Adds ok/0,ok/1, error/0, error/1 and error/2 functions to a module that uses it","ref":"UseCase.Interactor.html","title":"UseCase.Interactor","type":"module"},{"doc":"UseCase A way to increase Elixir projects readability and maintenance. Heavily inspired by Clean Architecture. We can join it with clean mixer for a very nice Clean Architecture code experience.","ref":"readme.html","title":"UseCase","type":"extras"},{"doc":"Installation About Creating Interactors Defining inputs Defining errors Default fields Composing with pipes Sending Options Mix Tasks Contribute","ref":"readme.html#table-of-contents","title":"UseCase - Table of contents","type":"extras"},{"doc":"The package can be installed by adding use_case to your list of dependencies in mix.exs: def deps do [ {:use_case, &quot;~&gt; 0.2.1&quot;} ] end","ref":"readme.html#installation","title":"UseCase - Installation","type":"extras"},{"doc":"Lets see some of the benefits from using the library (or only the idea behind use cases interactors). Imagine a library system where we have the context &quot;books&quot;. On normal Phoenix systems, the design may look like the example below: ▾ library/ ▾ books/ author.ex book.ex application.ex books.ex repo.ex There we have some problems: It is not yet clear what our application intend to do. Contexts files (books.ex) can get extremely fat with a lot of business logic. Now, thinking in use case interactors we can imagine Phoenix contexts as a Facade for your use cases, and do that: ▾ library/ ▾ books/ author.ex book.ex create_author.ex create_book.ex sell_book.ex application.ex books.ex repo.ex Our context will look like the example above: defmodule Library.Books do @moduledoc &quot;&quot;&quot; The Books context. &quot;&quot;&quot; import UseCase, only: [call: 1] import __MODULE__.{CreateAuthor, SellBook, CreateBook} @doc &quot;&quot;&quot; Creates a authors. iex&gt; create_authors(name) {:ok, %Library.Books.CreateAuthor.Output{ ... }} iex&gt; create_authors(bad_name) {:error, %Library.Books.CreateAuthor.Error{message: &quot;Bad name given&quot;}} &quot;&quot;&quot; def create_author(name), do: call(%CreateAuthor{name: name}) # ... def create_book(name, author), do: call(%CreateBook{name: name, author: author}) # ... def sell_book(book_id), do: call(%SellBook{book_id: book_id}) Let&#39;s say that now CreateBook, CreateAuthor and SellBook are gateways for our business rules. Controllers, views and even Phoenix know almost nothing about our business, they know that we can &quot;create books&quot; and &quot;sell books&quot;, and for that we need the params &quot;name&quot;, &quot;author&quot; or &quot;book_id&quot;, but nothing about what goes inside. Goals: Its clear what our application intend to do. It screams. Contexts files are only facades, an api for our use cases interactors to the external world. They dont know Repos or Schemas. When we call an use case interactor, we will get a specific output or an specific error from that use case (and we have a specific input too), making the system code more assertive in relation to what it is doing. And this is just the tip of the iceberg, to full enjoy this library, i recommend you to read the Clean Architecture book.","ref":"readme.html#about","title":"UseCase - About","type":"extras"},{"doc":"The most basic interactor can be created using the UseCase.Interactor module, defining an output for it and creating a call/2 function: defmodule SayHello do use UseCase.Interactor, output: [:message] def call(%{name: name}, _opts), do: ok(message: &quot;Hello \#{name}!&quot;) def call(%{name: nil}, _opts), do: error(&quot;name is obrigatory&quot;) end Now our SayHello module has the ok and error macros and a struct for Output like %SayHello.Output{message: &quot;something&quot;}. The ok and error macro can be used to define when our interactor success or fail. After define, we can call it in many ways: iex&gt; UseCase.call(SayHello, %{name: &quot;Henrique&quot;}) iex&gt; {:ok, SayHello.Output{message: &quot;Hello Henrique!&quot;, _state: nil}} iex&gt; SayHello.call(%{name: &quot;Henrique&quot;}) iex&gt; {:ok, SayHello.Output{message: &quot;Hello Henrique!&quot;, _state: nil}} iex&gt; UseCase.call(SayHello, %{name: nil}) iex&gt; {:error, SayHello.Error{message: &quot;name is obrigatory!&quot;}} iex&gt; UseCase.call!(SayHello, %{name: &quot;Henrique&quot;}) iex&gt; SayHello.Output{message: &quot;Hello Henrique!&quot;, _state: nil} iex&gt; UseCase.call!(SayHello, %{name: nil}) iex&gt; **** SayHello.Error name is obrigatory! Defining inputs Sometimes we want to guarantee the inputs our interactors will receive, we can do it defining this way: defmodule SayHello do use UseCase.Interactor, output: [:message], input: [:name] # Add this def call(%SayHello{name: name}, _opts), do: ok(message: &quot;Hello \#{name}!&quot;) def call(%SayHello{name: nil}, _opts), do: error(&quot;name is obrigatory&quot;) end Now, with UseCase module we can call it using the input directly: iex&gt; UseCase.call %SayHello{name: &quot;Henrique&quot;} iex&gt; {:ok, SayHello.Output{message: &quot;Hello Henrique!&quot;, _state: nil}} iex&gt; UseCase.call! %SayHello{name: &quot;Henrique&quot;} iex&gt; SayHello.Output{message: &quot;Hello Henrique!&quot;, _state: nil} Defining errors If we want to send extra informations in errors, we can do it as input and output. defmodule SayHello do use UseCase.Interactor, output: [:message], input: [:name], error: [:code] # Add this def call(%SayHello{name: name}, _opts), do: ok(message: &quot;Hello \#{name}!&quot;) def call(%SayHello{name: nil}, _opts), do: error(&quot;name is obrigatory&quot;, code: 500) # And use it end iex&gt; UseCase.call(SayHello, %{name: nil}) iex&gt; {:error, SayHello.Error{message: &quot;name is obrigatory!&quot;, code: 500}} Default fields When not defined, input, output and error defaults to: input: [:_state], output: [], error: [:message] Fields :_state in input and :message in error are always appended. The :_state field is very useful for pipe operations. Composing with pipes Lets define an LogOperation interactor: defmodule LogOperation do use UseCase.Interactor def call(%{message: message}, _opts) do # .. log message ok() end end We can compose with our SayHello simple as that: iex&gt; %SayHello{name: &quot;Henrique&quot;} |&gt; UseCase.pipe [SayHello, LogOperation] iex&gt; {:ok, LogOperation.Output{_state: nil}} iex&gt; UseCase.pipe [%SayHello{name: &quot;Henrique&quot;}, LogOperation] iex&gt; {:ok, LogOperation.Output{_state: nil}} iex&gt; UseCase.pipe [%SayHello{name: nil}, LogOperation] iex&gt; {:error, SayHello.Error{message: &quot;name is obrigatory!&quot;, code: 500}} iex&gt; %SayHello{name: &quot;Henrique&quot;} |&gt; UseCase.pipe! [SayHello, LogOperation] iex&gt; LogOperation.Output{_state: nil} iex&gt; UseCase.pipe! [%SayHello{name: &quot;Henrique&quot;}, LogOperation] iex&gt; LogOperation.Output{_state: nil} iex&gt; UseCase.pipe! [%SayHello{name: nil}, LogOperation] iex&gt; **** SayHello.Error name is obrigatory! All we need is match outputs and inputs and use one of pipe UseCase functions. Sending options All UseCase functions last argument is the options keyword list that is sent to interactors: import UseCase call(%SayHello{name: &quot;henrique&quot;}, my_option: true) %SayHello{name: &quot;Henrique&quot;} |&gt; pipe([SayHello, LogOperation], my_option: true) pipe([%SayHello{name: &quot;Henrique&quot;}, LogOperation], my_option: true)","ref":"readme.html#creating-interactors","title":"UseCase - Creating interactors","type":"extras"},{"doc":"mix use_case.gen.interactor mix use_case.gen.phx_resource mix use_case.gen.phx_resource_html mix use_case.gen.phx_resource_json mix use_case.gen.phx_resource_temple","ref":"readme.html#mix-tasks","title":"UseCase - Mix Tasks","type":"extras"},{"doc":"UseCase is not only for me, but for the Elixir community. I&#39;m totally open to new ideas. Fork, open issues and feel free to contribute with no bureaucracy. We only need to keep some patterns to maintain an organization: branchs your_branch_name or your-branch-name commits [your_branch_name] Your commit or [your-branch-name] Your commit","ref":"readme.html#contribute","title":"UseCase - Contribute","type":"extras"}]